﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Model;
using DevExpress.Xpo;
using RGPD.Module.BusinessObjects.RGPD;
using RGPD_Manager.Module.BusinessObjects.Non_Persistent;
using System;
using System.Collections.Generic;
using System.Linq;
using Xafari;
using Xafari.Controllers;
using Xafari.Model;

namespace RGPD_Manager.Module.Controllers
{
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppViewControllertopic.aspx.
    public partial class FormationAction : ViewController
    {
        private List<NonPersistentQuestion> nonPersistentQuestions;

        public FormationAction()
        {
            InitializeComponent();
            // Target required Views (via the TargetXXX properties) and create their Actions.
        }
        protected override void OnActivated()
        {
            base.OnActivated();
            // Perform various tasks depending on the target View.
        }
        protected override void OnViewControlsCreated()
        {
            base.OnViewControlsCreated();
            // Access and customize the target View control.
        }
        protected override void OnDeactivated()
        {
            // Unsubscribe from previously subscribed events and release other references and resources.
            base.OnDeactivated();
        }

        private void EnFormationAction_Execute(object sender, SimpleActionExecuteEventArgs e)
        {
            ((Utilisateur)View.CurrentObject).I_Formation = 0;
            ((Utilisateur)View.CurrentObject).D_Date_Formation = DateTime.Now;
            ObjectSpace.SetModified(View.CurrentObject);
            ObjectSpace.CommitChanges();
            ObjectSpace.Refresh();
        }

        private void Formation_Execute(object sender, SimpleActionExecuteEventArgs e)
        {

        }

        private void wizardAction1_Execute(object sender, PopupWindowShowActionExecuteEventArgs e)
        {
            //Fin du QCM
        }

        private void LancerQCM_CustomizePopupWindowParams(object sender, CustomizePopupWindowParamsEventArgs e)
        {
            var objectSpace = this.Application.CreateObjectSpace();
            
            var controller = XafariModule.CreateWizardDialogController(this.Application);
            controller.Model = this.Application.Model.Xafari().Wizards.GetWizard("QCMWizard");
            controller.CustomNextStep += controller_CustomNextStep;
            e.Context = controller.Model.TemplateContext;
            
            //Création du Question-Reponses
            int indexQuestion = 1;       
            nonPersistentQuestions = new List<NonPersistentQuestion>();
            XPCollection<Question> DBQuestions = ((FormationModule)View.CurrentObject).Questions;

            // Loop création des Steps du Module en Objet Non persistant
            foreach (Question question in DBQuestions.OrderBy(i=>i.Ordre))
            {
                //Création des questions du module
                IModelWizardStep step = (IModelWizardStep)controller.Model.GetNode("Step_" + indexQuestion.ToString());
                if (step == null)
                    step = controller.Model.AddNode<IModelWizardStep>("Step_" + indexQuestion.ToString());

                step.View = (IModelDetailView)Application.FindModelView("Wizard_Wizard1_Step_1");
                step.Index = indexQuestion;
                step.Caption = "Question " + indexQuestion.ToString();
                step.Description = string.Empty;

                //Bind les reponses
                int indexReponse = 1;
                NonPersistentQuestion tempQuestion = new NonPersistentQuestion() { Id = indexQuestion, Ordre = question.Ordre, Text = question.Text, Reponses = new List<NonPersistentReponse>() };             
                foreach(Reponse reponse in question.Reponses)
                {                   
                    tempQuestion.Reponses.Add(new NonPersistentReponse() { Id = indexReponse, Text = reponse.Text, Value = false });
                    indexReponse++;
                }

                nonPersistentQuestions.Add(tempQuestion);

                indexQuestion++;
            }

            e.DialogController = controller;

            var detailView = this.Application.CreateDetailView(objectSpace, controller.Model[0].View, true, null);
            detailView.ViewEditMode = ViewEditMode.Edit;
            e.View = detailView;
        }

        void controller_CustomNextStep(object sender, CustomNextStepEventArgs e)
        {
            var controller = (WizardDialogController)sender;
            var obj = nonPersistentQuestions.First(i=>i.Id == e.CurrentStep.Index + 1); 
            controller.CurrentObject = obj;          
        }

        private void wizardAction1_CreateWizardObject(object sender, Xafari.Actions.CreateWizardObjectEventArgs e)
        {

        }
    }
}
